#ifndef _h_ASM86_
#define _h_ASM86_

#ifndef _h_DOS_
# include <cv/dos.h>
#endif


#define I	asm

#define _CLR(r)	(r ^= r)

#define W0(ea)	(word ptr (ea))
#define W1(ea)	(word ptr (ea)[2])

#define BY0(ea)	(byte ptr (ea))
#define BY1(ea)	(byte ptr (ea)[1])


#if defined(__LARGE__) || defined(__HUGE__) || defined(__COMPACT__)
#define FARDATA
#endif

#if defined(__LARGE__) || defined(__HUGE__) || defined(__MEDIUM__)
#define FARCODE
#endif


#if defined(FARDATA)

#  define LES_		les
#  define LDS_		lds
#  define ES_		es:
#  define SS_		ss:
#  define DPTR_(ea)	dword(ea)
#  define pushDS_	I push ds
#  define popDS_	I pop ds

#else

#  define LES_	mov
#  define LDS_	mov
#  define ES_
#  define SS_
#  define DPTR_(ea)	word(ea)
#  define pushDS_
#  define popDS_

#endif

#define MAKE_LONG	(long)((void _seg*)(_DX) + (void near*)(_AX))
#define MAKE_ULONG	(unsigned long)((void _seg*)(_DX) + (void near*)(_AX))

enum CPU_FLAGS { Carry = 1, Parity = 4, Auxcarry = 0x10,
		 Zero = 0x40, Equal = Zero, Sign = 0x80, Trap = 0x100,
		 IEnable = 0x200, Direct = 0x400, Overflow = 0x800
};

#define isFLAG(mask) (_FLAGS & (mask))

#endif /* _h_ASM86_ */
