#ifndef _h_KEYS_
#define _h_KEYS_

enum keyCode {

/*  Control keys */
/**/
/*  NOTE: these Control key definitions are intended only to provide */
/*  mnemonic names for the ASCII control codes. They cannot be used */
/*  to define menu hotkeys, etc., which require scan codes. */

	kbCtrlA     = 0x0001,	kbCtrlB     = 0x0002,	kbCtrlC     = 0x0003,
	kbCtrlD     = 0x0004,	kbCtrlE     = 0x0005,	kbCtrlF     = 0x0006,
	kbCtrlG     = 0x0007,	kbCtrlH     = 0x0008,	kbCtrlI     = 0x0009,
	kbCtrlJ     = 0x000a,	kbCtrlK     = 0x000b,	kbCtrlL     = 0x000c,
	kbCtrlM     = 0x000d,	kbCtrlN     = 0x000e,	kbCtrlO     = 0x000f,
	kbCtrlP     = 0x0010,	kbCtrlQ     = 0x0011,	kbCtrlR     = 0x0012,
	kbCtrlS     = 0x0013,	kbCtrlT     = 0x0014,	kbCtrlU     = 0x0015,
	kbCtrlV     = 0x0016,	kbCtrlW     = 0x0017,	kbCtrlX     = 0x0018,
	kbCtrlY     = 0x0019,	kbCtrlZ     = 0x001a,

/* Extended key codes  */

	kbEsc       = 0x011B,	kbAltSpace  = 0x0200,
	kbShiftIns  = 0x0500,	kbShiftDel  = 0x0700,

	kbAltBack   = 0x0800,	kbBack      = 0x0E08,	kbCtrlBack  = 0x0E7F,
	kbShiftTab  = 0x0F00,	kbTab       = 0x0F09,	kbCtrlTab   = 0x9400,
	kbAltTab    = 0xA500,
	kbCtrlEnter = 0x1C0A,	kbEnter     = 0x1C0D,	kbAltEnter  = 0xA600,

	/* Alt+<Letter> key codes */
	kbAltQ      = 0x1000,	kbAltW      = 0x1100,	kbAltE      = 0x1200,
	kbAltR      = 0x1300,	kbAltT      = 0x1400,	kbAltY      = 0x1500,
	kbAltU      = 0x1600,	kbAltI      = 0x1700,	kbAltO      = 0x1800,
	kbAltP      = 0x1900,

	kbAltA      = 0x1E00,	kbAltS      = 0x1F00,	kbAltD      = 0x2000,
	kbAltF      = 0x2100,	kbAltG      = 0x2200,	kbAltH      = 0x2300,
	kbAltJ      = 0x2400,	kbAltK      = 0x2500,	kbAltL      = 0x2600,

	kbAltZ      = 0x2C00,	kbAltX      = 0x2D00,	kbAltC      = 0x2E00,
	kbAltV      = 0x2F00,	kbAltB      = 0x3000,	kbAltN      = 0x3100,
	kbAltM      = 0x3200,

	/* F-key codes */
	kbF1        = 0x3B00,	kbF2        = 0x3C00,	kbF3        = 0x3D00,
	kbF4        = 0x3E00,	kbF5        = 0x3F00,	kbF6        = 0x4000,
	kbF7        = 0x4100,	kbF8        = 0x4200,	kbF9        = 0x4300,
	kbF10       = 0x4400,	kbF11       = 0x8500,	kbF12       = 0x8600,

	/* Shift+F-key codes */
	kbShiftF1   = 0x5400,	kbShiftF2   = 0x5500,	kbShiftF3   = 0x5600,
	kbShiftF4   = 0x5700,	kbShiftF5   = 0x5800,	kbShiftF6   = 0x5900,
	kbShiftF7   = 0x5A00,	kbShiftF8   = 0x5B00,	kbShiftF9   = 0x5C00,
	kbShiftF10  = 0x5D00,	kbShiftF11  = 0x8700,	kbShiftF12  = 0x8800,

	/* Ctrl+F-key codes */
	kbCtrlF1    = 0x5E00,	kbCtrlF2    = 0x5F00,	kbCtrlF3    = 0x6000,
	kbCtrlF4    = 0x6100,	kbCtrlF5    = 0x6200,	kbCtrlF6    = 0x6300,
	kbCtrlF7    = 0x6400,	kbCtrlF8    = 0x6500,	kbCtrlF9    = 0x6600,
	kbCtrlF10   = 0x6700,	kbCtrlF11   = 0x8900,	kbCtrlF12   = 0x8A00,

	/* Alt+F-key codes */
	kbAltF1     = 0x6800,	kbAltF2     = 0x6900,	kbAltF3     = 0x6A00,
	kbAltF4     = 0x6B00,	kbAltF5     = 0x6C00,	kbAltF6     = 0x6D00,
	kbAltF7     = 0x6E00,	kbAltF8     = 0x6F00,	kbAltF9     = 0x7000,
	kbAltF10    = 0x7100,	kbAltF11    = 0x8B00,	kbAltF12    = 0x8C00,

	/* <Cursor> key codes */
	kbHome      = 0x4700,	kbUp        = 0x4800,	kbPgUp      = 0x4900,
	kbLeft      = 0x4B00,	kbGray5     = 0x4C00,	kbRight     = 0x4D00,
	kbEnd       = 0x4F00,	kbDown      = 0x5000,	kbPgDn      = 0x5100,

	kbGrayMinus = 0x4A2D,	kbGrayPlus  = 0x4E2B,
	kbIns       = 0x5200,	kbDel       = 0x5300,

	/* Ctrl+<Cursor> key codes */
	kbCtrlPrtSc = 0x7200,
	kbCtrlHome  = 0x7700,	kbCtrlUp    = 0x8D00,	kbCtrlPgUp  = 0x8400,
	kbCtrlLeft  = 0x7300,	kbCtrlGray5 = 0x8F00,	kbCtrlRight = 0x7400,
	kbCtrlEnd   = 0x7500,	kbCtrlDown  = 0x9100,	kbCtrlPgDn  = 0x7600,

	kbCtrlGrayMinus = 0x8E00, kbCtrlGrayPlus = 0x9000,
	kbCtrlIns   = 0x0400,	kbCtrlDel   = 0x0600,

	/* Alt+<Cursor> key codes */
	kbAltHome   = 0x9700,	kbAltUp     = 0x9800,	kbAltPgUp   = 0x9900,
	kbAltLeft   = 0x9B00,				kbAltRight  = 0x9D00,
	kbAltEnd    = 0x9F00,	kbAltDown   = 0xA000,	kbAltPgDn   = 0xA100,

	kbAltGrayMinus = 0x4A00, kbAltGrayPlus = 0x4E00,
	kbAltIns    = 0xA200,	kbAltDel    = 0xA300,

	/* Alt+<Numeric> key codes */
	kbAlt1      = 0x7800,	kbAlt2      = 0x7900,	kbAlt3      = 0x7A00,
	kbAlt4      = 0x7B00,	kbAlt5      = 0x7C00,	kbAlt6      = 0x7D00,
	kbAlt7      = 0x7E00,	kbAlt8      = 0x7F00,	kbAlt9      = 0x8000,
	kbAlt0      = 0x8100,	kbAltMinus  = 0x8200,	kbAltEqual  = 0x8300,

	kbNoKey     = 0x0000
}; /* keyCode */

/*  Keyboard state and shift masks */

struct kbShiftState{
	unsigned	rightShift	:1,
			leftShift	:1,
			ctrlShift	:1,
			altShift	:1,
			scrollState	:1,
			numState	:1,
			capsState	:1,
			insState	:1;
};

#endif /* _h_KEYS_ */
